#bash.nsi: script for use with Nullsoft NSIS 
#	Free software with documentation from 
#	<http://www.nullsoft.com/free/nsis>
#	This script follows the structure described in nsis12c
#
# Copyright (C) 2001 Joshua Daniel Franklin
# 
#    This is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#
#Header configuration commands
Name "cygwin-1.1.8-2 Lite"
Icon src\cygwin.ico
OutFile cygwin-lite-1-1-8-2f.exe
CRCCheck on
UninstallText "This will uninstall Cygwin-Lite from your system."
UninstallExeName uninst-cygwin.exe
#
#Licence page configuration commands
LicenseText "Cygwin-Lite is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY.  See the following License for more details."
LicenseData html\gpl.txt
#
#Component page configuration commands
ComponentText "This will install Cygwin-Lite on your computer."
InstType Normal
InstType Minimal
EnabledBitmap src\enabled.bmp
DisabledBitmap src\disabled.bmp
#
#Directory Selection page configuration commands
DirText "NOTICE: A Full install is required for rebuilding Cygwin-Lite." 
InstallDir "C:\cygwin"
InstallDirRegKey HKEY_LOCAL_MACHINE "Software\Cygnus Solutions\Cygwin\mounts v2\/" "native"
#
#Install page configuration commands
AutoCloseWindow false
ShowInstDetails hide
#
#Installation Execution command, gets messy from here!
Section "Cygwin 1-1-8.2 and GNU tools"
SetOutPath $INSTDIR\src
File src\bashrc
File src\bash95.pif
File src\bashNT.pif
File src\cygwin.ico
File src\setup.bat
File src\setup.pif
File src\setup.sh
SetOutPath $INSTDIR\src\home
File /r src\home\*.*
SetOutPath $INSTDIR\etc
File etc\profile
SetOutPath $INSTDIR\etc\profile.d
CopyFiles "$INSTDIR\src\setup.sh" "$INSTDIR\etc\profile.d\setup.sh" 2
ExecWait '$INSTDIR\src\setup.bat "$INSTDIR"'			;creates bash.bat file with correct install directory
CopyFiles "$INSTDIR\src\bashNT.pif" "$INSTDIR\bash.pif" 1 	;assume WinNT to begin with
IfFileExists "$SYSDIR\cmd.exe" 3 0				;if we found cmd.exe, we were right!
IfFileExists "$WINDIR\command.com" 1 0				;NOT there either, there's a problem, assume win9x
MessageBox MB_OK "Could not determine if Windows 9x or NT. Assumed Win9x...if not, edit bash.pif in the Installation Directory, or just link to /src/bash95.pif (Please email joshuadfranklin@yahoo.com if you get this message.)" IDOK 0 
CopyFiles "$INSTDIR\src\bash95.pif" "$INSTDIR\bash.pif" 1 	;skipped if command.com doesn't exist
WriteRegStr HKEY_LOCAL_MACHINE "SOFTWARE\Cygnus Solutions\Cygwin\Program Options" "" ""
WriteRegDWord HKEY_LOCAL_MACHINE "SOFTWARE\Cygnus Solutions\Cygwin\mounts v2\/" "flags" "0x0000008"
WriteRegStr HKEY_LOCAL_MACHINE "SOFTWARE\Cygnus Solutions\Cygwin\mounts v2\/" "native" "$INSTDIR"
WriteRegDWord HKEY_LOCAL_MACHINE "SOFTWARE\Cygnus Solutions\Cygwin\mounts v2\/usr/bin" "flags" "0x00000008"
WriteRegStr HKEY_LOCAL_MACHINE "SOFTWARE\Cygnus Solutions\Cygwin\mounts v2\/usr/bin" "native" "$INSTDIR\bin"
WriteRegDWord HKEY_LOCAL_MACHINE "SOFTWARE\Cygnus Solutions\Cygwin\mounts v2\/usr/lib" "flags" "0x00000008"
WriteRegStr HKEY_LOCAL_MACHINE "SOFTWARE\Cygnus Solutions\Cygwin\mounts v2\/usr/lib" "native" "$INSTDIR\lib"
WriteRegStr HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\Cygwin-lite" "DisplayName" "Cygwin-Lite (remove only)"
WriteRegStr HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\Cygwin-lite" "UninstallString" '"$INSTDIR\uninst-cygwin.exe"'
WriteRegStr HKEY_LOCAL_MACHINE "Software\CLASSES\Directory\shell\Cygwin-Lite" "" "&Run GNU bash"
WriteRegStr HKEY_LOCAL_MACHINE "Software\CLASSES\Directory\shell\Cygwin-Lite\command" "" '$INSTDIR\bash.bat %1'
WriteRegStr HKEY_LOCAL_MACHINE "Software\CLASSES\Drive\shell\Cygwin-Lite" "" "&Run GNU bash"
WriteRegStr HKEY_LOCAL_MACHINE "Software\CLASSES\Drive\shell\Cygwin-Lite\command" "" '$INSTDIR\bash.bat %1'
WriteRegStr HKEY_LOCAL_MACHINE "Software\CLASSES\Folder\shell\Cygwin-Lite" "" "&Run GNU bash"
WriteRegStr HKEY_LOCAL_MACHINE "Software\CLASSES\Folder\shell\Cygwin-Lite\command" "" '$INSTDIR\bash.bat %1'
SetOverwrite off
SetOutPath $INSTDIR\bin
File bin\bash.exe
File bin\cat.exe
File bin\cp.exe
File bin\cygpath.exe
File bin\cygwin1.dll
File bin\find.exe
File bin\grep.exe
File bin\id.exe
File bin\less.exe
File bin\ls.exe
File bin\mkdir.exe
File bin\mount.exe
File bin\mv.exe
File bin\rm.exe
File bin\rmdir.exe
File bin\sh.exe
File bin\umount.exe
File bin\wc.exe
SetOutPath $INSTDIR\home
SetOutPath $INSTDIR\html
File html\gpl.txt
File html\begin.html
CreateShortCut "$INSTDIR\Beginner's Guide.lnk" "$INSTDIR\html\begin.html" "" "" 0
SetOutPath $INSTDIR\lib
SetOutPath $INSTDIR\tmp

Section "Source scripts"
SectionIn 12
SetOverwrite on
SetOutPath $INSTDIR\src
File src\readme.txt
File src\bash.nsi
File src\buildleft.plx
File src\changelog
File src\COMPILING
File src\convert.sh
File src\dirlisting
File src\disabled.bmp
File src\enabled.bmp
File src\makensis.exe
File src\notice.txt
File src\nsislister.sh

Section "Start Menu Group"
SectionIn 12
SetOutPath $SMPROGRAMS\Cygwin-Lite
SetOutPath $INSTDIR
CreateShortCut "$DESKTOP\bash.lnk" "$INSTDIR\bash.pif" "" "$INSTDIR\src\cygwin.ico" 0
CreateShortCut "$QUICKLAUNCH\bash.lnk" "$INSTDIR\bash.pif" "" "$INSTDIR\src\cygwin.ico" 0
CreateShortCut "$SMPROGRAMS\Cygwin-Lite\bash.lnk" "$INSTDIR\bash.pif" "" "$INSTDIR\src\cygwin.ico" 0
CreateShortCut "$SMPROGRAMS\Cygwin-Lite\Beginner's Guide.lnk" "$INSTDIR\html\begin.html" "" "" 0
CreateShortCut "$SMPROGRAMS\Cygwin-Lite\Uninstall Cygwin-Lite.lnk" "$INSTDIR\uninst-cygwin.exe" "" "" 0

Section "Compression: tar, gzip"
SectionIn 1
SetOutPath $INSTDIR\bin
File bin\gzip.exe
File bin\tar.exe

Section "Vi IMproved: vim, vimtutor"
SectionIn 1
SetOutPath $INSTDIR\usr\share\vim
SetOutPath $INSTDIR\src\tinyvim
File src\tinyvim\help.txt
File src\tinyvim\intro.txt
File src\tinyvim\tags
File src\tinyvim\tutor
File src\tinyvim\uganda.txt
File src\tinyvim\vim.exe
File src\tinyvim\vimtutor

Section "HTML documentation (man pages)"
SectionIn 1
SetOutPath $INSTDIR\html
File html\bash.html
File html\begin.html
File html\cp.html
File html\cat.html
File html\cygpath.html
File html\find.html
File html\grep.html
File html\guide.html
File html\gzip.html
File html\index.html
File html\id.html
File html\less.html
File html\left.html
File html\ls.html
File html\mkdir.html
File html\mount.html
File html\mv.html
File html\rmdir.html
File html\sh.html
File html\tar.html
File html\umount.html
File html\wc.html
File html\vi.html
CreateShortCut "$INSTDIR\User's Guide.lnk" "$INSTDIR\html\guide.html" "" "" 0
CreateShortCut "$STARTMENU\Programs\Cygwin-Lite\User's Guide.lnk" "$INSTDIR\html\guide.html" "" "" 0

Section -post
Exec '"notepad" "$INSTDIR\html\gpl.txt"'

Section Uninstall
DeleteRegKey HKEY_CURRENT_USER  "SOFTWARE\Cygnus Solutions"
DeleteRegKey HKEY_LOCAL_MACHINE "SOFTWARE\Cygnus Solutions"
DeleteRegKey HKEY_LOCAL_MACHINE "SOFTWARE\CLASSES\Directory\shell\Cygwin-Lite"
DeleteRegKey HKEY_LOCAL_MACHINE "SOFTWARE\CLASSES\Drive\shell\Cygwin-Lite"
DeleteRegKey HKEY_LOCAL_MACHINE "SOFTWARE\CLASSES\Folder\shell\Cygwin-Lite"
DeleteRegKey HKEY_LOCAL_MACHINE "Software\Microsoft\Windows\CurrentVersion\Uninstall\Cygwin-lite"
Delete $STARTMENU\Programs\Cygwin-Lite\*
RMDir $STARTMENU\Programs\Cygwin-Lite
Delete $DESKTOP\bash.lnk
Delete $DESKTOP\bash.pif
Delete $QUICKLAUNCH\bash.lnk
Delete $QUICKLAUNCH\bash.pif
Delete "$INSTDIR\User's Guide.lnk"
Delete $INSTDIR\bash.pif
Delete $INSTDIR\bash.lnk
Delete $INSTDIR\bash.bat
Delete $INSTDIR\.bash_history
RMDir /r $INSTDIR\usr
RMDir /r $INSTDIR\tmp
RMDir /r $INSTDIR\src
RMDir /r $INSTDIR\lib
RMDir /r $INSTDIR\html
RMDir $INSTDIR\home
RMDir /r $INSTDIR\etc
RMDir /r $INSTDIR\bin
Delete $INSTDIR\uninst-cygwin.exe
MessageBox MB_YESNO|MB_ICONQUESTION "Do you want to delete all files? (Answer NO to keep your /home directory.)" IDNO 1
RMDir /r "$INSTDIR" ; skipped if no
; skipped if no
