#
#
# This script is called by /etc/profile
echo "Performing Initial Setup, Please Wait"
echo "If you are unfamiliar with GNU bash, please read the Beginner's Guide"

#the lazy way to include things in Cygwin-Lite is to put them in /src/home/
shopt -s dotglob		#gets hidden files
cp -r /src/home/* $HOME/	#notice this WILL OVERWRITE
shopt -u dotglob	

#test so we don't overwrite included preferences 
if [ ! -f $HOME/.bashrc ]; then
	cp /src/bashrc $HOME/.bashrc
fi

#behaviour of several executables is determined by name only; copy them
if [ -f /bin/gzip.exe ]; then
	cp /bin/gzip.exe /bin/gunzip.exe
fi
#copy vim to /bin and set up vim runtime dir (if vim was installed)
if [ -f /src/tinyvim/vim.exe ]; then
	cp /src/tinyvim/vim* /bin/		#if you want to use rview, etc
	cp /bin/vim.exe /bin/ex.exe		#you can also copy vim to those
	if [ ! -d /usr/share/vim/doc ]; then
		mkdir /usr/share/vim/doc
	fi
	cp /src/tinyvim/*txt /src/tinyvim/tags /usr/share/vim/doc/
	if [ ! -d /usr/share/vim/tutor ]; then
		mkdir /usr/share/vim/tutor
	fi
	cp /src/tinyvim/tutor /usr/share/vim/tutor
	
fi
mv /etc/profile.d/setup.sh /src
